part of xwidgetbase;

class XfxSchedaTabbed extends StatefulWidget {
  XfxSchedaTabbed({
    Key? key,
    this.titleScheda = "",
    this.backgroudColorOfScheda,
    this.visibleXContainerWithLabelOnTop = true,
    this.listOfChildren,
    this.childrenOfTabViewer,
    this.numberOfTabs,
    this.tabs,
    this.bottomNavigationBarvisible = true,
    this.isScrollableTabs = false,
    this.onTapOnBTNofMenu,
    this.currentIndexOfBottomMenu,
    this.backgroundColorTabs,
    this.tabController,
    this.onTapForGestureInSch,
    this.horizontalMarginOfElenco,
    this.textStyleOfElTitle,
    required this.childrenOfBottomBar,
  }) : super(key: key);
  final String titleScheda;
  final bool visibleXContainerWithLabelOnTop;
  final List<Widget>? listOfChildren;
  final TabController? tabController;
  final List<Widget>? childrenOfTabViewer;
  final int? numberOfTabs;
  final bool? bottomNavigationBarvisible;
  final List<Widget>? tabs;
  final bool? isScrollableTabs;
  Function()? onTapForGestureInSch;
  final int? currentIndexOfBottomMenu;
  final Function(int)? onTapOnBTNofMenu;
  final double? horizontalMarginOfElenco;
  List<BottomNavigationBarItem> childrenOfBottomBar;
  final Color? backgroundColorTabs;
  final Color? backgroudColorOfScheda;
  final TextStyle? textStyleOfElTitle;
  @override
  _XfxSchedaTabbedState createState() => _XfxSchedaTabbedState();
}

tabViewerPagesSch(String titleScheda, Widget? childOfSchedaTabViewer, List<BottomNavigationBarItem> childrenOfBottomBar) {
  return XfxScheda(bottomNavigationBarvisible: false, titleScheda: titleScheda, child: childOfSchedaTabViewer, childrenOfBottomBar: childrenOfBottomBar);
}

templateSchedaViewerSch(
  String subTitle,
  String descr,
) {
  return Column(
    children: [
      SizedBox(height: 5),
      XContainerWithLabel(
        subTitle,
        color: XColors.backgroundDark,
        alignmentContainer: Alignment.centerLeft,
        textStyle: XStyles.xStyTextForLabel(),
      ),
      SizedBox(height: 5),
      XContainerWithLabel(
        descr,
        color: XColors.backgroundDark,
        alignmentContainer: Alignment.centerLeft,
        textAlignment: TextAlign.left,
        textStyle: XStyles.xStyTextForLabel(),
      ),
    ],
  );
}

tabPagesSch(
  IconData icon,
  String? label, {
  TextStyle? styleLabel,
  Color? colorIcons,
}) {
  return Tab(
      icon: Icon(icon, color: colorIcons ?? Colors.white),
      child: Text(
        label ?? "",
        style: styleLabel ?? XStyles.xStyTextForDescr(colorIcons ?? Colors.white),
      ));
}

class _XfxSchedaTabbedState extends State<XfxSchedaTabbed> {
  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return DefaultTabController(
        length: widget.numberOfTabs!,
        child: Scaffold(
            backgroundColor: widget.backgroudColorOfScheda,
            body: Container(
                margin: EdgeInsets.symmetric(horizontal: widget.horizontalMarginOfElenco ?? 15),
                child: Column(children: [
                  widget.visibleXContainerWithLabelOnTop == true ? SizedBox(height: 10) : SizedBox(height: 0),
                  widget.visibleXContainerWithLabelOnTop == true
                      ? Row(
                          children: [
                            Expanded(child: XContainerWithLabel(widget.titleScheda, height: 30, color: XColors.backGroundTitleContainerForScheda_MAIN, textStyle: widget.textStyleOfElTitle ?? TextStyle(fontSize: 18))),
                          ],
                        )
                      : Container(),
                  widget.visibleXContainerWithLabelOnTop == true ? SizedBox(height: 3) : SizedBox(height: 0),
                  TabBar(
                    controller: widget.tabController,
                    indicator: BoxDecoration(color: widget.backgroundColorTabs),
                    isScrollable: widget.isScrollableTabs!,
                    tabs: widget.tabs!,
                    onTap: (idx) {
                      FocusScopeNode currentFocus = FocusScope.of(context);
                      if (!currentFocus.hasPrimaryFocus && currentFocus.focusedChild != null) {
                        FocusManager.instance.primaryFocus?.unfocus();
                      }
                    },
                  ),
                  Expanded(
                      child: Container(
                          child: TabBarView(
                    children: widget.childrenOfTabViewer!,
                    controller: widget.tabController,
                  ))),
                  SizedBox(height: 5),
                ])),
            bottomNavigationBar: widget.bottomNavigationBarvisible == true
                ? BottomNavigationBar(
                    type: BottomNavigationBarType.fixed,
                    currentIndex: widget.currentIndexOfBottomMenu ?? 0,
                    onTap: widget.onTapOnBTNofMenu,
                    enableFeedback: true,
                    showUnselectedLabels: true,
                    selectedItemColor: Colors.blue[700],
                    selectedFontSize: 15,
                    selectedLabelStyle: XStyles.xStyleText(),
                    backgroundColor: Colors.grey[900],
                    unselectedItemColor: XColors.foregroundLight,
                    unselectedFontSize: 10,
                    unselectedLabelStyle: XStyles.xStyleText(),
                    iconSize: 20,
                    items: widget.childrenOfBottomBar,
                  )
                : Container(
                    height: 1,
                  )));
  }
}
